function y=BiOrthogonalWavelet79Rows(x,col)

% Determine the type of signal (vector or image)
s=size(x);
M=s(1);
N=s(2);

y=0;

% Compute coefficients for the lifting scheme of the wavelet
a =-1.586134;
b=-0.05298011;
c=0.882911;
d=0.4435068;
K=1.149604398;
%K=1;

if (col)
    % Process columns first
    img.Even = x(:,1:2:N); % Even samples of columns
    img.Odd = x(:,2:2:N); % Odd samples of columns
    
    % First stage
    y.s1=zeros(M,N/2);
    y.s1 = img.Odd + a*(img.Even+[img.Even(:,2:N/2) img.Even(:,N/2)]);
    
    % Second stage
    y.s2 = img.Even + b*(y.s1+[y.s1(:,1) y.s1(:,1:N/2-1)]);
    
    % Third stage
    y.H = y.s1 + c*(y.s2+[y.s2(:,2:N/2) y.s2(:,N/2)]);
    
    % Second stage
    y.L = y.s2 + d*(y.H+[y.H(:,1) y.H(:,1:N/2-1)]); 
    
    y.L=K*y.L;
    y.H=y.H/K;
    y.comp = [y.L y.H];    
else
    % Process columns first
    img.Even = x(1:2:M,:); % Even samples of columns
    img.Odd = x(2:2:M,:); % Odd samples of columns
    
    % First stage
    y.s1=zeros(M/2,N);
    y.s1 = img.Odd + a*(img.Even+[img.Even(2:M/2,:);img.Even(M/2,:)]);
    
    % Second stage
    y.s2 = img.Even + b*(y.s1+[y.s1(1,:);y.s1(1:M/2-1,:)]);
    
    % Third stage
    y.H = y.s1 + c*(y.s2+[y.s2(2:M/2,:);y.s2(M/2,:)]);
    
    % Second stage
    y.L = y.s2 + d*(y.H+[y.H(1,:);y.H(1:M/2-1,:)]); 
    
    y.L=K*y.L;
    y.H=y.H/K;
    y.comp = [y.L;y.H];
end

% y=BiOrthogonalWavelet79Rows(x,0); %For Rows
% y=BiOrthogonalWavelet79Rows(x,1); %For Columns