function [y2,y3,data]=im2jpeg2k(x1,res,bpp)


%x=im2double(x1)*255-128;
x=im2double(x1)-0.5;
[M N]=size(x);
if (and(M>=128,N>=128))
    cb_size = 64; % Code Bolck size
else
    cb_size = 32; % Code Bxolck size
end

maxRate = M*N*bpp;

data.size = size(x);
data.res = res;
data.bpp=bpp;

z1=x;
% Compute multiresolution res bi-orthogonal wavelet 7-9
z=BiOrthogonalWavelet79(z1,0);
y=z.comp;
for k=2:res
    z1=z.comp(1:size(z.comp,1)/2,1:size(z.comp,2)/2);
    z=BiOrthogonalWavelet79(z1,0);
    y(1:size(z.comp,1),1:size(z.comp,2))=z.comp;
end

imshow(y,[]);

% Quantization process ()
data.max=max(abs(y(:)));
y=y/max(abs(y(:)));
y1=fix(127*y);
%figure;imshow(y1,[]);

numBlocks=0;
y2 = [];
slopes = ones(size(y1,1)/cb_size*size(y1,2)/cb_size,cb_size*cb_size);
indexSlopes = ones(1,size(y1,1)/cb_size*size(y1,2)/cb_size);

maxTruncPoints = 0;
slopesVect = [];
rateVect = [];
idBlockVect = [];
BitStream = [];

for resol=res:-1:1
    % Process LL subband of resoltion res
    s_res = size(y1)/2^resol;
    nBk = s_res/cb_size;
    if (resol==res)
        subband_start = 1; % Only process subband 'LL' for the lower resolution
    else
        subband_start = 2;
    end
    
    for subband=subband_start:4
        if (subband==1)
            xStart = 0;
            yStart = 0;
            sband = 'LL';
        else
            if (subband==2)
               xStart = 0;
               yStart = s_res(2);
               sband = 'HL';
            else
                if (subband==3)
                   xStart = s_res(1);
                   yStart = 0;
                   sband = 'LH';
                else
                   xStart = s_res(1); 
                   yStart = s_res(2);
                   sband = 'HH';
                end
            end
        end
        
        for j=1:nBk(1)
            xc = xStart +(j-1)*cb_size+1;
            for k=1:nBk(2)
                yc = yStart + (k-1)*cb_size+1;
                y3=Embedded_block_Encoder(y1(xc:xc+cb_size-1,yc:yc+cb_size-1),sband);
                y3.x = xc; % x init point
                y3.y = yc; % y init point
                y3.n = 1; % Actual truncating point
                %y3.smax =  % Max slope from n
                y2 = [y2 y3];
                numBlocks = numBlocks + 1;
                slopes(numBlocks,1:size(y3.slope,2)) = y3.slope;
                rates(numBlocks,1:size(y3.R,2)) = y3.R;
                slopesVect = [slopesVect 1 y3.slope];
                rateVect = [rateVect 0 (y3.R(2:end)-y3.R(1:end-1))];
                idBlockVect = [idBlockVect numBlocks*ones(1,size(y3.R,2))];
                BitStream = [BitStream y3.bs];
                if (size(y3.R,2) > maxTruncPoints)
                    maxTruncPoints = size(y3.R,2);
                end
                %figure;
                plot(y3.R,y3.D);hold on;
                %plot(y3.R(y3.K),y3.D(y3.K),'r');title(['codeBlock: ',num2str(numBlocks)]);
                %figure;plot(y3.slope);
            end
        end
    end
end
slopes=slopes(:,1:maxTruncPoints);
tRate = 0;

%[lm2,p2,lm,prob,nelements]=huffmanEncoder(BitStream);

j=0;

%while (tRate < maxRate)
    %j = j + 1;
    %[C,I]=sort(slopes(:,j)); 
    %sumRate = cumsum(rates(I,j+1));
    %indRate = max(find(sumRate<=maxRate));
    %tRate = tRate + sumRate;
%end

data.slopesVect = slopesVect;
data.rateVect = rateVect;
data.idBlockVect = idBlockVect;
data.cb_size = cb_size;

[~,I]=sort(slopesVect); % Vector I indexes the numbers of blocks with least slopes
sumRate = cumsum(rateVect(I));
indRate = find(sumRate<=maxRate,1,'last');

%layer1=y2(1).wRec
y3 = zeros(size(y1));
lx = size(y1,2)/cb_size;

nextPoint = ones(1,numBlocks);

for k=1:indRate
    j=idBlockVect(I(k));
    %q = rem(j-1,lx)+1;
    %p = fix((j-1)/lx) + 1;
    r = nextPoint(j);
    %y3((p-1)*cb_size+1:p*cb_size,(q-1)*cb_size+1:q*cb_size) = reshape(y2(j).wRec(r,:),[cb_size cb_size]);
    y3(y2(j).x:y2(j).x+cb_size-1,y2(j).y:y2(j).y+cb_size-1) = reshape(y2(j).wRec(r,:),[cb_size cb_size]);
    nextPoint(j) = nextPoint(j) + 1;
end

figure;imshow(y3,[]);title(['DWT truncated at rate: ', num2str(bpp)]);
%sm=max(y2(1).slope)
%x=imread('lenna.jpg');x=rgb2gray(x);[y2,y3,data]=im2jpeg2k(x,3,0.125);
