function [recImg, error, error_int, DC, numACcoeff]=jpegColor(imgName,k,showImages)

 img2=imread(imgName);
 
 img=im2double(img2)*255;
 
 s=size(img);
 s2=size(s);
 
 recImg = img;
 
 if (s2(2)==3)
     % RGB Components
     R=img(:,:,1);
     G=img(:,:,2);
     B=img(:,:,3);
     % Compute luminance Y and chrominances Cr and Cb
     Y=0.299*R + 0.587*G + 0.114*B;
     Cb = -0.1687*R-0.3313*G+0.5*B+128;
     Cr = 0.5*R-0.4187*G-0.0813*B+128;
     
     % JPEG Compression for luminance
     [recImgLum,qMat,DC,numACcoeff]=jpeg1(Y,k,0); 
     
     % JPEG Compression for red chrominance
     [recImgCr,qMat2]=jpeg1(Cr,k,1); 
     
     % JPEG Compression for blue chrominance
     [recImgCb,qMat3]=jpeg1(Cb,k,1);
     
     % Recover the compressed values for RGB
     R1=recImgLum+1.40210*(recImgCr-128);
     G1=recImgLum-0.34414*(recImgCb-128)-0.71414*(recImgCr-128);
     B1=recImgLum + 1.77180*(recImgCb-128);
     
     if (showImages)
        figure;
        subplot(1,2,1);imshow(Y/255);title('Original Luminance');
        subplot(1,2,2);imshow(recImgLum/255);title('Compressed Luminance');
        
        figure;
        subplot(1,2,1);imshow(Cr/255);title('Original red Chrominance');
        subplot(1,2,2);imshow(recImgCr/255);title('Compressed red Chrominance');
        
        figure;
        subplot(1,2,1);imshow(Cb/255);title('Original blue Chrominance');
        subplot(1,2,2);imshow(recImgCb/255);title('Compressed blue Chrominance');

        figure;
        subplot(1,3,1);imshow(R1/255);title('Compressed Red');
        subplot(1,3,2);imshow(G1/255);title('Compressed Green');
        subplot(1,3,3);imshow(B1/255);title('Compressed Blue');
     end
     recImg(:,:,1) = R1;
     recImg(:,:,2) = G1;
     recImg(:,:,3) = B1;
 else
    [recImg,qMat,DC,numACcoeff]=jpeg1(img,k,0);
 end
 
 if (showImages)
    figure;
    subplot(1,2,1);imshow(img/255);
    subplot(1,2,2);imshow(recImg/255,[0,1]);
    figure;
    hist(DC,50);
    sDC = size(DC);
    DC2=DC(1:8:sDC(2));
    figure;
    stem(DC2);
    figure;
    hist(DC2,50);
 end
 
 % AC coeffcients Bit compression computation
 Cb = s(1)*s(2)/(sum(2*numACcoeff))
 % Mean quadratic error
 recImg2 = recImg-min(recImg(:));
 recImg2 = im2uint8(recImg2);
 error = sum(sum((img-recImg).^2))/(s(1)*s(2));
 [error,psnr]=mse(img/255,recImg/255,8);
 error_int = sum(sum((img2-recImg2).^2))/(s(1)*s(2));
 %xr = (img-min(img(:)))/(max(img(:))-min(img(:)));
 %yr = (recImg-min(recImg(:)))/(max(recImg(:))-min(recImg(:)));
 %error2 = sum(sum((xr-yr).^2))/(s(1)*s(2));
 % Example
 % [jpegImg,error,DC,numACcoeff]=jpegColor('lenna.jpg',1,0);